require("maptools")
require("maps")
require("rgeos")
require("raster")
require("rgdal")
LL2UTM<-function(lon,lat){
  utmz<-(floor((lon + 180)/6) %% 60) + 1
  #Special Cases for Norway & Svalbard
  if(lat>55 & utmz==31 & lat<64 & lon>2)utmz<-32
  if(lat>71 & utmz==32 & lon<9)utmz<-31
  if(lat>71 & utmz==32 & lon>8)utmz<-33
  if(lat>71 & utmz==34 & lon<21)utmz<-33
  if(lat>71 & utmz==34 & lon>20)utmz<-35
  if(lat>71 & utmz==36 & lon<33)utmz<-35
  if(lat>71 & utmz==36 & lon>32)utmz<-37
  utmz
}
if(exists("Offs")== FALSE){Offs<-0}
#source("C:/Users/aanes/Documents/SUSTAIN/grid/progs.R")
make_grid<-function(x, cell_diameter, cell_area, clip = FALSE,type="hexagonal") {
  if (missing(cell_diameter)) {
    if (missing(cell_area)) {
      stop("Must provide cell_diameter or cell_area")
    } else {
      if(type=="hexagonal")cell_diameter <- sqrt(2 * cell_area / sqrt(3))
      if(type=="regular")cell_diameter <- sqrt(cell_area)
    }
  }
  ext <- as(extent(x) + cell_diameter, "SpatialPolygons")
  projection(ext) <- projection(x)
  # generate array of hexagon centers
  g <- spsample(ext, type = type, cellsize = cell_diameter, offset = c(0.5, 0.5))
  # convert center points to hexagons
  if(type=="hexagonal")g <- HexPoints2SpatialPolygons(g, dx = cell_diameter)
  projattr<-attributes(g)$proj4string
  h0<<-g
  print("1")
  if(type=="regular"){
    #g <- sp::makegrid(g, cellsize = cell_area)
    g <- makegrid(g, cellsize = cell_area)
    print("1.5")
    g<-SpatialPoints(g)
    #proj4string(g)<-proj4string(x)
    g<-points2grid(g)
    #h1<<-g
    print("2")
    #g<-as.SpatialPolygons.GridTopology(h1,proj4string=projattr )
    g<-as.SpatialPolygons.GridTopology(g,proj4string=projattr )
    print("2.5")
  }
  # clip to boundary of study area
  #h2<<-g
  if (clip) {
    g <- gIntersection(g, x, byid = TRUE)
  } else {
    g <- g[x, ]
  }
  # clean up feature IDs
  print("3")
  row.names(g) <- as.character(1:length(g))
  return(g)
}

###############

mymap <- maps::map("world", interior=TRUE, plot=FALSE,fill=T, xlim=c(-15,40),ylim=c(58,85))
IDs<-sapply(strsplit(mymap$names, ":"), "[", 1L)
mymapPS<-map2SpatialPolygons(mymap, IDs=IDs, proj4string=CRS("+proj=longlat +datum=WGS84"))


xlim<-c(5+Offs,60+Offs)
ylim<-c(65+Offs,80+Offs)

#Create spatial study area
Sr1<-Polygon(cbind(c(xlim[1],xlim[2],xlim[2],xlim[1],xlim[1]),c(ylim[1],ylim[1],ylim[2],ylim[2],ylim[1])))
Srs1<-Polygons(list(Sr1), "s1")
SpP<-SpatialPolygons(list(Srs1), pO=as.integer(1),proj4string=CRS("+proj=longlat +ellps=WGS84"))

#Determine UTM zone and transform to be able to create hex grid with appropriate scales
LL2UTM(mean(xlim),mean(ylim))
SpP_utm <- spTransform(SpP,CRS("+proj=utm +zone=37 +datum=WGS84 +units=km +no_defs"))


hex_grid_M <- make_grid(SpP_utm, cell_area = a, clip = FALSE)

hex_grid_LL_M <- spTransform(hex_grid_M,CRS("+proj=longlat +ellps=WGS84"))